#include "StdAfx.h"
#include "SATDevices.h"

bool CSATDevices::s_bEnableAndroid = true;
ULONGLONG CSATDevices::s_ulEraseDuration = 30000;
ThreadSection CSATDevices::s_ThreadSection;
std::vector<STAndroid> CSATDevices::s_vtAndroids;

void Split(vector<std::string>& vtLine, std::string strLines, const std::string strSplit)
{
	if (strLines.size() == 0 || strSplit.size() == 0)
		return;

	int nIndex = 0;
	vtLine.clear();
	std::string strtmp;
	while (std::string::npos != (nIndex = strLines.find(strSplit))) {
		strtmp = strLines.substr(0, nIndex);
		if (strtmp.size())vtLine.push_back(strtmp);
		strLines = strLines.substr(nIndex + strSplit.size());
	}

	if (strLines.size())
		vtLine.push_back(strLines);
}

std::string ExecuteCMD(std::string cmd)
{
	SECURITY_ATTRIBUTES sa = {0};
	HANDLE hRead = NULL, hWrite = NULL;
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;

	// ܵ;
	if ( !CreatePipe(&hRead, &hWrite, &sa, 1024) )
	{
		return "";
	}

	STARTUPINFO si = {0};
	PROCESS_INFORMATION pi = {0};
	si.cb = sizeof(STARTUPINFO);
	GetStartupInfo(&si);

	si.hStdError = hWrite;
	si.hStdOutput = hWrite;
	si.wShowWindow = SW_HIDE;
	si.dwFlags = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	// ӽ;
	TCHAR szCommand[MAX_PATH] = {0};
	_tcscpy_s(szCommand,cmd.c_str());
	if ( !CreateProcess(NULL, szCommand, NULL, NULL, TRUE, NULL, NULL, NULL, &si, &pi) )
	{
		CloseHandle(hRead);
		CloseHandle(hWrite);
	}

	// ȴ̽;
	WaitForSingleObject(pi.hProcess, INFINITE);

	// ͷо;
	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);
	CloseHandle(hWrite);

	// ȴд;
	Sleep(200);
	// ȡ;
	DWORD dwBytesRead;
	TCHAR szBuffer[1024] = {0};
	ReadFile(hRead, szBuffer, 1024, &dwBytesRead, NULL);
	CloseHandle(hRead);

	// ؽ;
	return std::string(szBuffer);
}

CSATDevices::CSATDevices(void)
{
	m_hEvent = NULL;
	m_hWorkThread = NULL;

	// һ豸;
	AddVirtualDevices("192.168.1.999:5555");
}

CSATDevices::~CSATDevices(void)
{
}

void CSATDevices::StartWork()
{
	m_hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	if ( m_hEvent == NULL )
	{
		return;
	}

	m_hWorkThread = CreateThread(NULL, 0, WorkThread, this, 0, NULL);
	if ( m_hWorkThread == NULL)
	{
		SetEvent(m_hEvent);
		CloseHandle(m_hEvent);
		CloseHandle(m_hWorkThread);
		m_hEvent = NULL;
		m_hWorkThread = NULL;
		return;
	}
}

void CSATDevices::EndofWork()
{

}

DWORD CSATDevices::WorkThread(LPVOID lpVoid)
{
	CSATDevices *that = (CSATDevices*)lpVoid;
	do 
	{
		if ( !s_bEnableAndroid )
			continue;

		// ˢµǰ豸б;
		std::vector<STAndroid> vtAndroids;
		printf("GetCurrentDevices\n");
		// ȡǰ豸б;
		GetCurrentDevices(vtAndroids);

		// 豸бǷ豸;
		std::vector<STAndroid>::iterator it = s_vtAndroids.begin();
		for ( ;it != s_vtAndroids.end(); ) {
			if ( it->nType == Virtual ) {
				it++;
				continue;
			}

			if ( IsAndroidOffline(*it, vtAndroids) ) {
				printf("IsAndroidOffline\n");
				if ( GetTickCount64() - it->ulOfflineTime > s_ulEraseDuration ) {
					// Ƴ豸(Ҫ̼߳);
					it = s_vtAndroids.erase(it);
				} else {
					if ( it->nType == Reticle ) {
						// 豸,;
						std::string str = "adb connect ";
						str.append(it->strName);
						WinExec(str.c_str(), SW_HIDE);
					} else if ( it->nType == Usb ) {
						// usbĻ,Ҫkill-server,ȫ;
						WinExec("adb kill-server", SW_HIDE);
						// ;
						ReConnectAllDevices();
					}

					it++;
				}
			}
			else
				it++;
		}
	} while (WaitForSingleObject(that->m_hEvent, 1000) == WAIT_TIMEOUT);

	printf("end thread\n");
	return 0;
}

void CSATDevices::AddReticleDevices(std::string ip)
{
	STAndroid stAndroid;
	stAndroid.nType = Reticle;
	stAndroid.strName = ip;
	stAndroid.ulOfflineTime = 0;

	AutoThreadSection ats(&s_ThreadSection);
	if (!IsDeviceExist(stAndroid))
		s_vtAndroids.push_back(stAndroid);
}

void CSATDevices::AddVirtualDevices(std::string name)
{
	STAndroid stAndroid;
	stAndroid.nType = Virtual;
	stAndroid.strName = name;
	stAndroid.ulOfflineTime = 0;

	AutoThreadSection ats(&s_ThreadSection);
	if (!IsDeviceExist(stAndroid))
		s_vtAndroids.push_back(stAndroid);
}

bool CSATDevices::IsDeviceExist(STAndroid &stAndroid)
{
	bool bExist = false;
	std::vector<STAndroid>::iterator it = s_vtAndroids.begin();
	for(; it != s_vtAndroids.end(); it++ ) {
		if ( _tcscmp(it->strName.c_str(), stAndroid.strName.c_str()) == 0 ) {
			bExist = true;
			break;
		}
	}

	return bExist;
}

bool CSATDevices::IsAndroidOffline(STAndroid &stAndroid, std::vector<STAndroid> &vtAndroids )
{
	bool bOffline = true;
	// ڵǰ豸бѯ;
	std::vector<STAndroid>::iterator it = vtAndroids.begin();
	for(; it != vtAndroids.end(); it++ ) {
		if ( _tcscmp(it->strName.c_str(), stAndroid.strName.c_str()) == 0 ) {
			bOffline = false;
			break;
		}
	}

	if ( bOffline ) {
		if ( stAndroid.ulOfflineTime == 0 ) {
			// ״μ⵽;
			stAndroid.ulOfflineTime = GetTickCount64();
		}
	} else {
		// ,ʱ;
		if ( stAndroid.ulOfflineTime ) {
			stAndroid.ulOfflineTime = 0;
		}
	}	

	return bOffline;
}

bool CSATDevices::IsAndroidOffline(std::string strAndroidName, std::vector<STAndroid> &vtAndroids )
{
	bool bOffline = true;
	// ڵǰ豸бѯ;
	std::vector<STAndroid>::iterator it = vtAndroids.begin();
	for(; it != vtAndroids.end(); it++ ) {
		if ( _tcscmp(it->strName.c_str(), strAndroidName.c_str()) == 0 ) {
			bOffline = false;
			break;
		}
	}

	if ( bOffline ) {
		if ( it->ulOfflineTime == 0 ) {
			// ״μ⵽;
			it->ulOfflineTime = GetTickCount64();
		}
	} else {
		// ,ʱ;
		if ( it->ulOfflineTime ) {
			it->ulOfflineTime = 0;
		}
	}

	return bOffline;
}

bool CSATDevices::IsNewAndroid(STAndroid &stAndroid)
{
	bool bNewAndroid = true;
	std::vector<STAndroid>::iterator it = s_vtAndroids.begin();
	for(; it != s_vtAndroids.end(); it++ ) {
		if ( _tcscmp(it->strName.c_str(), stAndroid.strName.c_str()) == 0 ) {
			bNewAndroid = false;
			break;
		}
	}

	// 豸(һusb)
	if ( bNewAndroid ) {
		AutoThreadSection ats(&s_ThreadSection);
		s_vtAndroids.push_back(stAndroid);
	}

	return bNewAndroid;
}

bool CSATDevices::IsNewUsbAndroid(STAndroid &stAndroid)
{
	if ( stAndroid.nType != Usb )
		return false;

	bool bNewAndroid = true;
	std::vector<STAndroid>::iterator it = s_vtAndroids.begin();
	for(; it != s_vtAndroids.end(); it++ ) {
		if ( it->nType != Usb )
			continue;
		if ( _tcscmp(it->strName.c_str(), stAndroid.strName.c_str()) == 0 ) {
			bNewAndroid = false;
			break;
		}
	}

	// 豸(һusb)
	if ( bNewAndroid ) {
		AutoThreadSection ats(&s_ThreadSection);
		s_vtAndroids.push_back(stAndroid);
	}

	return bNewAndroid;
}

void CSATDevices::GetCurrentDevices(std::vector<STAndroid> &vtAndroids)
{
	std::string strLines = ExecuteCMD("adb devices");
	std::vector<std::string> vtLine;
	Split(vtLine, strLines, "\r\n");
	int npos = -1;
	// Ҫڴ˴˵offlineusb豸,Ҫvt;
	for ( std::vector<std::string>::iterator it = vtLine.begin(); it != vtLine.end(); it++ ) {
		// ֻȡ豸,豸;
		if ( (npos = it->find("	device")) != std::string::npos ) {
			STAndroid stAndroid;
			if ( it->find(":5555") == std::string::npos )
				stAndroid.nType = Usb;
			else
				stAndroid.nType = Reticle;
			stAndroid.ulOfflineTime = 0;
			stAndroid.strName = it->substr(0, npos);
			// 豸һusb豸
			IsNewAndroid(stAndroid);
			vtAndroids.push_back(stAndroid);
		}
	}
}

void CSATDevices::ReConnectAllDevices()
{
	std::string str;
	std::vector<STAndroid>::iterator it = s_vtAndroids.begin();
	for ( ;it != s_vtAndroids.end(); it++ ) {
		if ( it->nType == Reticle ) {
			str = "adb connect ";
			str.append(it->strName);
			WinExec(str.c_str(), SW_HIDE);
		}
	}
}